%define ver	031220
%define	name	links-hacked
%define	release	10mdk

Summary:	Lynx-like text WWW browser
Name:		%{name}
Version:	0.0.%{ver}
Release:	%{release}
License:	GPL
Group:		Networking/WWW
Source0:	%{name}-%{ver}.tar.bz2
Source1:	links-16.png
Source2:	links-32.png
Source3:	links-48.png
Source4:        links.cfg
Source5:	links-fonts-new.tar.bz2
Patch7:		links-0.96-no-domain-security.patch.bz2
Patch8:		links-current-color-by-default--and-vt100-frames.patch.bz2
Patch10:	links-2.0pre1-be-graphic-when-called-_links-graphic_.patch.bz2
Patch11:	links-hacked-030620-convert-old-bookmarks-in-new-format.patch.bz2
Patch12:	links-hacked-030620-fix-default-charset.patch.bz2
Patch13:	links-hacked-030709-config-file.patch.bz2
Patch15:	links-hacked-031220-gcc34.patch.bz2
Patch16:	links-hacked-031220-lua5.patch.bz2
Patch17:	links-hacked-031220-lua5compil.patch.bz2
Patch18:	links-hacked-031220-gcc401.patch.bz2
URL:		http://xray.sai.msu.ru/~karpov/links-hacked/
BuildConflicts: libsvgalib1-devel
BuildRequires:	gpm-devel ncurses-devel png-devel jpeg-devel lua-devel > 5.0.2-1mdk
BuildRequires:	ncurses-devel => 5.0 
BuildRequires:	freetype2-devel tiff-devel directfb-devel
BuildRequires:	openssl-devel
Provides:	webclient
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
# (tv) explicit requires b/c of broken SONAME in lua:
%ifarch x86_64 sparc64
Requires: lib64lua5
%else
Requires: liblua5
%endif

%description
Links is a text based WWW browser, at first look similar to Lynx, but
somehow different:

- renders tables and frames
- displays colors as specified in current HTML page
- uses drop-down menu (like in Midnight Commander)
- can download files in background
- partially handle Javascript

Links-hacked is based on top of links and offer the below features:
- Lua scripting
- HTTP Auth - stable, ported form Elinks 
- Blocking of selected images 
- Cookies saving
- New options system (c-o)
- Open new windows instead of new links instances in graphics mode
- Url copying
- Full-text selection
- Simple printing
- Forward history
- Extended and configurable 'toolbar'
- Configurable 'mini-status'
- various small improvements:
  o support for "small" and "big" tags,
  o keybinding ("i") to turn on/off images,
  o possibility to show HTTP header ("|"),
  o support for compressed content
  o configurable support for Accept-Charset and Accept-Language. 
- Modularized font subsystem
- Font manager (c-i)
- Dialogs shadows and borders
- Tabbed browsing

%prep
%setup  -q -n %name-%ver
%patch7 -p1
%patch8 -p1
%patch10 -p1
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch15 -p0
%patch16 -p0 -b .lua
%patch17 -p0 -b .lua5
%patch18 -p0 -b .gcc401

chmod a+r *

%build
[[ -f configure ]] || ./autogen.sh
perl -pi -e 's!"-g!"!g' configure
cp -a %SOURCE5 .

%configure --enable-graphics --enable-javascript
(cd Unicode ; LC_ALL=C ./gen )
# even more dirty :)
perl -pi -e 's!wget xray.sai.msu.ru/\~karpov/links-hacked/downloads/links-fonts-new.tgz \&\& tar xzvf links-fonts-new.tgz!tar -jxvf links-fonts-new.tar.bz2!' Makefile{,.am,.in}

%make || :
# hacky & dirty
perl -pi -e 's!^@.*!!' utils/Makefile
%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall

rm -f %buildroot%{_bindir}/links
install links %buildroot%{_bindir}/%name

install -D -m 644 %SOURCE4 %buildroot/etc/links.cfg

install -d %buildroot/%_menudir/
cat << EOF >$RPM_BUILD_ROOT%{_menudir}/%{name}
?package(%{name}):  \
  command="/usr/bin/%name" \
  needs="X11" \
  icon="%name.png" \
  section="Networking/WWW" \
  title="Links (hacked version)" longtitle="Lynx-like text/graphic WWW browser"
EOF

install -d %buildroot/%_liconsdir/
install -d %buildroot/%_miconsdir/
install -m 644 %SOURCE1 %buildroot/%_miconsdir/%name.png
install -m 644 %SOURCE2 %buildroot/%_iconsdir/%name.png
install -m 644 %SOURCE3 %buildroot/%_liconsdir/%name.png
# fix conflicts with links-graphic:
mv %buildroot/%_mandir/man1/{links,%name}.1

%clean
rm -rf $RPM_BUILD_ROOT

%triggerpostun -- links
if [ ! -e /usr/bin/links ]; then
  update-alternatives --auto links
fi

%post
%{update_menus}
update-alternatives --install /usr/bin/links links /usr/bin/%name 5

%postun
%{clean_menus}
if [ "$1" = "0" ]; then
  update-alternatives --remove links /usr/bin/%name
fi

%files 
%defattr(-,root,root)
%doc AUTHORS BUGS ChangeLog README SITES TODO 
%config(noreplace) /etc/links.cfg
%_bindir/%name
%_bindir/arrow
%_bindir/generate_font
%_bindir/make_included
%_bindir/rasterizer
%_mandir/*/*
%_menudir/%name
#
%_miconsdir/*.png
%_iconsdir/*.png
%_liconsdir/*.png


%changelog
* Fri Jul 08 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.031220-10mdk
- fix requires oin x86_64

* Fri Jul 08 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.031220-9mdk
- patch 18: fix build with gcc-4.0.1
- fix build on x86_64

* Fri Apr 29 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.031220-8mdk
- rebuild for yet another gtk+fb library

* Wed Apr 20 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.031220-7mdk
- rebuild for new gtk+fb library
- fix buildrequires

* Sun Aug 29 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.031220-6mdk
- really avoid wget during build
- rebuild with lua5
- fix bogus lua requires, aka requires a fixed lua (previously it accepted
  either lua4 or lua5 thus resulting in linkinkg issues at runtime)
- patch 16: fix detecting lua5
- patch 17: fix compiling with lua5

* Fri Aug 13 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 0.0.031220-5mdk
- Rebuild with new menu

* Wed Jul 28 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.031220-4mdk
- patch 15: fix compiling with new g++
- rebuild w/o svgalib support

* Wed Apr 07 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.031220-3mdk
- decrease alternative priority in order to please lord pixel

* Mon Dec 29 2003 Franck Villaume <fvill@freesurf.fr> 0.0.031220-2mdk
- fix some 64bits buildrequires
- avoid wget during build : patch14
- add BuildRequires for : OpenSSL, Freetype, tiff support

* Sat Dec 20 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.031220-1mdk
- new release

* Wed Nov 19 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.030709-2mdk
- patch 13: do not share anymore config file with links (conflicted options)
- fix conflicts with links-graphic

* Wed Aug 20 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.030709-1mdk
- new snapshot

* Tue Jul 08 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.030620-3mdk
- remove patch 3 : this was the one that break url uudecode, thus making "open
  in new window/tab" stoping working

* Tue Jul 01 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.030620-2mdk
- patch 12: fix default charset

* Thu Jun 26 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.030620-1mdk
- new release
- remove patch 4 (other fix upstream)
- remove patch 12 (accepted upstream)
- rediff patch 11

* Mon May 19 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.030507-1mdk
- new release (very slow on x11, fast on console :-( )
- remove patch 1 since it now make colors look horrible on console
- rediff patch 11
- patch 12: fix build system
- fix buildrequires

* Thu Apr 24 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.030316-2mdk
- fix update-alternative in %%postun

* Tue Mar 25 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 0.0.030316-1mdk
- initial release
